package top.ninwoo.test;


import com.pitong.business.item.DataPackage;
import com.pitong.business.item.Picture;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.Banner;
import org.springframework.boot.WebApplicationType;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import top.ninwoo.test.doMap.DoMap;
import top.ninwoo.test.doMap.path;
import top.ninwoo.test.transfer.TransferService;

import java.io.*;
import java.net.Socket;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

@SpringBootApplication
@path
public class BisheTestMain implements ApplicationRunner {

    @Autowired
    private TransferService transferService;
    @Value("${targetIp}")
    private String targetIp;

    public static void main(String[] args) {
        new SpringApplicationBuilder(BisheTestMain.class)
                .web(WebApplicationType.NONE) // .REACTIVE, .SERVLET
                .bannerMode(Banner.Mode.OFF)
                .run(args);
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {


        System.out.println("========================================");
        System.out.println("launch timestamp: " + System.currentTimeMillis());

        System.out.println();

//      输入：
        //子任务依赖关系 边
        int[][] link = {{0, 0, 1, 2, 3, 4, 5}, {1, 2, 3, 4, 5, 5, 6}};
        //task编号
        int[] func = {2, 3, 3, 1, 1, 4, 5};
        //task列表
        String[] tasks = {" ","binaryProcess", "cutProcess", "greyProcess", "mergeProcess", "tailorProcess"};
//        //功能分支表
//        int[][] branch = {{1, 1},{1, 2},{1, 1},{2, 1},{1, 1}};

        DoMap doMap = new DoMap();
        doMap.doMapApp(link,func);
        //映射结果
        int[] result = doMap.result;
        boolean flag = repetition(result);
        while (result[0] == 0 || flag){
//            System.out.println("failure mapping ："+Arrays.toString(result));
            doMap.doMapApp(link,func);
            result = doMap.result;
            flag = repetition(result);
        }
        System.out.println("optimal mapping scheme"+Arrays.toString(result));

        DataPackage dataPackage = new DataPackage();
        //路径表
        String[] path = new String[link[0].length];
        for (int tm = 0;tm<link[0].length;tm++){
            //左为边起点，右为边终点
            path[tm] = "sate"+result[link[0][tm]]+"->"+"sate"+result[link[1][tm]];
        }
        dataPackage.setPathTable(path);
        //任务表
        ConcurrentHashMap<String,String> taskTable = new ConcurrentHashMap();
        for (int tm = 0;tm<result.length;tm++){
            taskTable.put("sate"+result[tm],tasks[func[tm]]);
        }
        dataPackage.setTaskTable(taskTable);

        //T3路由表
        int [][] lastHop = doMap.lastHop;
        String[][] route = new String[lastHop.length][lastHop[0].length];
        for(int i =0;i<lastHop.length;i++){
            for (int j=0;j<lastHop[0].length;j++){
                route[i][j] = "sate"+(lastHop[i][j]+1);
                if (route[i][j].equals("sate1")){
                    route[i][j]="sate"+(j+1);
                }
            }
        }
        boolean flad = false;
        for(int i =0;i<lastHop.length;i++){
            for (int j=0;j<lastHop[0].length;j++){
                if (route[i][j].equals("sate"+(i+1)) && i!=j){
                    flad = true;
                }
            }
        }
        if (flad==false){
            System.out.println("correct");
        }


        dataPackage.setRoute(route);
        System.out.println("exec start timestamp: " + System.currentTimeMillis());
        System.out.println("========================================");
        System.out.println();

        String file_path = "passport.jpg";
//        G:\code\cnf\
        Picture picture = loadPicture(file_path);
        dataPackage.setPicture(picture);
        dataPackage.setCurrentSataHop("sate1");
        dataPackage.setNextSataHop("sate1");
        dataPackage.setDestinSataHop("sate1");

        Date date = new Date();
        long time = date.getTime();
        transferService.transferPackage(dataPackage,dataPackage.getCurrentSataHop(),time);

    }





    private boolean repetition(int[] result) {
        HashSet<Integer> set = new HashSet<>();
        for (int a : result){
            set.add(a);
        }
        if (set.size()==result.length) return false;
        else return true;
    }

    private void creatParent(File dirpath) {
        File file = new File(dirpath.getParent());
        if (!file.exists()) {
            creatParent(file);
            file.mkdir();
        }
    }


    private static Picture loadPicture(String pic_url) {
        try {
            File f = new File(pic_url);
            InputStream is = new FileInputStream(f);
            byte[] b = new byte[(int) f.length()];
            is.read(b);
            is.close();
            Picture picture = new Picture();
            picture.setData(b);
            return picture;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

/*    private static void send(DataPackage dataPackage, String ip, int port) {
        Socket socket = null;
        try {
            socket = new Socket(ip, port);
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(dataPackage);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (socket != null) {
                    socket.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }*/

}


/*        List<Integer> sequence = new ArrayList<>();
        for (int a:result
             ) {
            sequence.add(a);
        }*/

//边映射结果T2
/*        int[][] edgeMaps = new int[2][link[0].length];
        edgeMaps[0][0] = 2;
        for (int tm = 0;tm<link[0].length;tm++){
            //第一列为边起点，第二列为边终点
            edgeMaps[0][tm] = result[link[0][tm]];
            edgeMaps[1][tm] = result[link[1][tm]];
        }*/

/*

    HashMap<Integer,Integer> nodeMaps = new HashMap();
        nodeMaps.put(1,func[0]);
                for (int tm = 0;tm<link[0].length;tm++){
        if (!nodeMaps.containsKey(result[link[1][tm]])){
        //key值为节点映射卫星编号，value值为图像处理功能编号
        nodeMaps.put(result[link[1][tm]],func[link[1][tm]]);
        }
        }*/
