package com.pitong.business.service.transfer.impl;

import com.pitong.business.service.transfer.FindService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.concurrent.ConcurrentHashMap;

@Service
public class FindServiceImpl implements FindService {
    @Override
    public ArrayList<String> findDestinSataHops(String[] pathTable, String currenthop) {
        ArrayList<String>  destinSataHops = new ArrayList<String>();
        int j = 0;

        if(pathTable.length == 0){
            System.out.println("路径表为空");
            destinSataHops.add("nopara");
            return destinSataHops;
        }
        for (int i = 0; i < pathTable.length; i++) {
            //判断本机是否为路径起点
            if(currenthop.equals(pathTable[i].split("->")[0])){
                destinSataHops.add(pathTable[i].split("->")[1]);
            }
        }
        if(destinSataHops.size() == 0){
            destinSataHops.add("nolast");
        }
        return destinSataHops;
    }

    @Override
    public String[] findRoute(String currentSataHop,String[][] routeTable) {
        //判断路由表是否存在
        if(routeTable.length == 0){
            System.out.println("路由表为空");
            return null;
        }
        //找到本机路由表
        String[] route = this.findCurrentRoute(currentSataHop,routeTable);
        return route;
    }

    @Override
    public String findNextHop(String destinSataHop, String[] route) {
        int index = Integer.parseInt(destinSataHop.split("sate")[1]);
        String nextHop = route[index-1];
        return nextHop;
    }

    @Override
    public String findTask(String currenSataHop, ConcurrentHashMap<String, String> taskMap) {
        if(taskMap.isEmpty()){
            System.out.println("无任务表");
            return null;
        }
        return taskMap.get(currenSataHop);
    }


    //找到本卫星的路由
    private String[] findCurrentRoute(String sataname, String[][] routeTable){
        int index = Integer.parseInt(sataname.split("sate")[1]);
        System.out.println(index);
        return routeTable[index-1];
    }
}

