package com.pitong.business.service.transfer.impl;

import com.pitong.business.item.DataPackage;
import com.pitong.business.service.transfer.TransferService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import top.ninwoo.bishe.starter.service.NetworkService;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;

@Service
public class TransferServiceImpl implements TransferService {

    @Value("${slot}")
    private Long slot;  //时隙值

    @Autowired
    private NetworkService networkService;

    //转发函数，需要增加
    @Override
    public void transferPackage(DataPackage dataPackage, String nextHop, long startime) {
        //获取目标节点ip
        String app_name = nextHop;
        System.out.println(app_name);
        String IP = this.getIpByAppName(app_name);
        System.out.println(IP);
        //发送至目标
        send(dataPackage, IP, 2020, startime);
    }

    //发送数据包
    private void send(DataPackage dataPackage, String ip, int port, Long startime) {
        Socket socket = null;
        try {
            socket = new Socket(ip, port);
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(dataPackage);
        } catch (IOException e) {
            Long waitime = slot-(System.currentTimeMillis()-startime)%slot;
            try {
                Thread.sleep(waitime+10);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            System.out.println(">>>>>>>>>>>>>>>>>>>");
            System.out.println("blocked current slot: " + ((System.currentTimeMillis()-startime)/slot + 1));
            System.out.println("try again ...");
            send(dataPackage, ip, port, startime);
        } finally {
            try {
                if (socket != null) {
                    socket.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    //不应该有这个函数
    public String getIpByAppName(String appName) {
        List<String> ipList = networkService.getIpListByAppName(11111l, appName);
        if(!ipList.isEmpty()){
            String ip_tmp = ipList.get(0);
            String[] split_list = ip_tmp.split("/");
            return split_list[0];
        }
        return null;
    }
}